package dev.shadowsoffire.apotheosis.util;

import com.mojang.datafixers.kinds.Applicative;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.NBTAdapter;
import net.minecraftforge.registries.ForgeRegistries;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.level.Level;
import java.util.Optional;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.entity.EntityType;
import com.mojang.serialization.Codec;

public class SupportingEntity
{
    public static Codec<SupportingEntity> CODEC;
    public final EntityType<?> entity;
    protected final CompoundTag nbt;
    protected final double x;
    protected final double y;
    protected final double z;
    
    public SupportingEntity(final EntityType<?> entity, final Optional<CompoundTag> nbt, final double x, final double y, final double z) {
        this.entity = entity;
        this.nbt = nbt.orElse(null);
        this.x = x;
        this.y = y;
        this.z = z;
    }
    
    public Mob create(final Level level, final double x, final double y, final double z) {
        final Mob ent = (Mob)this.entity.m_20615_(level);
        if (this.nbt != null) {
            ent.deserializeNBT(this.nbt);
        }
        ent.m_6034_(this.x + x, this.y + y, this.z + z);
        return ent;
    }
    
    static {
        SupportingEntity.CODEC = (Codec<SupportingEntity>)RecordCodecBuilder.create(inst -> inst.group((App)ForgeRegistries.ENTITY_TYPES.getCodec().fieldOf("entity").forGetter(t -> t.entity), (App)PlaceboCodecs.nullableField(NBTAdapter.EITHER_CODEC, "nbt").forGetter(t -> Optional.ofNullable(t.nbt)), (App)PlaceboCodecs.nullableField((Codec)Codec.DOUBLE, "x", (Object)0.0).forGetter(t -> t.x), (App)PlaceboCodecs.nullableField((Codec)Codec.DOUBLE, "y", (Object)0.0).forGetter(t -> t.y), (App)PlaceboCodecs.nullableField((Codec)Codec.DOUBLE, "z", (Object)0.0).forGetter(t -> t.z)).apply((Applicative)inst, SupportingEntity::new));
    }
}
